#!/usr/bin/perl

#-----------------------------------------------------------------#
#          CGI ø -= dapibbs  ũƮ =-           #
#                                                                 #
#        Presented by Hwang Soo-yeon (dapi@innocent.com)          #
#                     <URL> http://dapi.pr.co.kr/                 #
#-----------------------------------------------------------------#
# This script is originally based upon 'stlfbbs' produced by      #
# Naoto Mochizuki (http://www.blk.mmtr.or.jp/~stlf/softwares/),   #
# and modified by Hwang Soo-yeon (http://dapi.pr.co.kr/).         #
# Released with original author's permission. All rights reserved.#
#-----------------------------------------------------------------#
# Update Information                                              #
#                                                                 #
# v0.996: 1999/08/04.  cgi   ѱ κ      #
# v0.997: 1999/08/13. н带 ȣȭϰ / ƾ ߰   #
# v0.998: 1999/08/23.  cgi    ߰            #
# v1.0  : 1999/09/04. The 1st public release                      #
# v1.1  : 1999/11/01. ª ǥ ɼǰ  ѱ κ     #
#                     ڿ  κ ȯ漳 ߰          #
# v1.12 : 1999/11/15. URLǥ . 亯 HTML   #
#-----------------------------------------------------------------#

# ȭ Include

require './dapibbs.ini';

# form data ޴´

if ($ENV{'REQUEST_METHOD'} eq "POST") { 
	read(STDIN, $form_info, $ENV{'CONTENT_LENGTH'}); 
} else { $form_info = $ENV{'QUERY_STRING'}; }

# form data decode

@key_value_pairs = split(/&/, $form_info);

foreach $key_value (@key_value_pairs) {
	($key, $value) = split(/=/, $key_value);
	$value =~ tr/+/ /;
	$value =~ s/%([\dA-Fa-f][\dA-Fa-f])/pack("C", hex($1))/eg;

	$value =~ s/&/&amp;/g;
	$value =~ s/&amp;\#([0-9]+);/&\#$1;/g;
	$value =~ s/</&lt;/g;
	$value =~ s/>/&gt;/g;
	$value =~ s/"/&quot;/g;

	$value =~ s/ ;;/&nbsp;;;/g;
#	$value =~ s/<!--d-->//ig;

	$FORMDAT{$key} = $value;
}

# vertical text number from .ini
$vnum = $subnum;

# page number control
if ($FORMDAT{'pnum'} =~ /^\d+$/) { $pnum = $FORMDAT{'pnum'}; }
if($pnum eq '') { $pnum = 1; }
if ($pnum > 1) { $pnum_pre = $pnum - 1; }
else { $pnum_pre = 1; }
$pnum_nex = $pnum + 1;

# form data decode 
$name = $FORMDAT{'name'};
$addr = $FORMDAT{'addr'};
$url = $FORMDAT{'url'};
$subj = $FORMDAT{'subj'};
$note = $FORMDAT{'note'};
$cookie = $FORMDAT{'cookie'};
$mode = $FORMDAT{'mode'};

if ($clkurl eq 'on') {
	$note =~ s/(http:\/\/[\w\.\/\~\-\+\=\#\%\&\?\(\);]+)/<A HREF="$1" TARGET="_blank">$1<\/A>/ig;
}

if ($taguse eq 'on') { $note =~ s/&lt;(\/?(B|I|S|U))&gt;/<$1>/ig; }

$name =~ s/\r|\n//g;
$addr =~ s/\r|\n//g;
$url =~ s/\r|\n//g;
$subj =~ s/\r|\n//g;

$note =~ s/\r\n/<BR>/g;
$note =~ s/\r|\n/<BR>/g;
$note =~ s/(<BR>)*$//;

if ($addr !~ /.+\@.+\..+/) { $addr = ''; }
if ($url !~ /http:\/\/.{3,}/) { $url = ''; }

if ($mode eq 'reg') {
	if ($note ne '') { &regist; }
	&mkcook;
} else { &cookie; }

if ($url eq '') { $url = 'http://'; }
if ($name eq '') { $cook = 'CHECKED'; } else { $cook = ''; }

# file lock

if ($lock ne 'off') { &filelock; }

# log file 

open(LOGFILE, $logfile) || &return_error('dapibbs', 'log file  ʽϴ. ۹̼   ְų file   ɼ ֽϴ.');
@logs = <LOGFILE>;
close(LOGFILE);

# HTML file(1) 

open(OPUT, $output_html) || &return_error('dapibbs', 'HTML file(1)  ʽϴ.   ɼ ֽϴ.');
@dapioput = <OPUT>;
close(OPUT);

# HTML file(2) 

open(SPUT, $suboutput_html) || &return_error('dapibbs', 'HTML file(2)  ʽϴ.   ɼ ֽϴ.');
@dapisput = <SPUT>;
close(SPUT);

# file unlock

if ($lock ne 'off') { unlink($lockfile); }

# calculate total page number

$tline = $#logs + 1;
if (($tline % $vnum) != 0) { $tpage = int($tline / $vnum) + 1; }
else { $tpage = int($tline / $vnum); }

# divide into pages

for ($i = 1; $i < $pnum; $i++) {
	for ($j = 0; $j < $vnum; $j++) {
		shift(@logs);
	}
}
if ($#logs >= $vnum) { $#logs = $vnum - 1; }
else { $pnum_nex = $pnum; }

if (($pnum_pre == 1) && ($pnum_pre == $pnum)) { $p_prev = $thisfirst; }
else { $p_prev = '<A HREF="./dapibbs.cgi?pnum=' . $pnum_pre . '">' . $toprev . '</A>'; }
if (($pnum_nex == $tpage) && ($pnum_nex == $pnum)) { $p_next = $thislast; }
else { $p_next = '<A HREF="./dapibbs.cgi?pnum=' . $pnum_nex . '">' . $tonext . '</A>'; }

chop(@logs);

# HTML 

print 'Content-type: text/html', "\n";
print 'Pragma: no-cache', "\n\n";

print '<!------------------------------------------------>', "\n";
print '<!--    -= dapibbs =- the guestboard system     -->', "\n";
print '<!--          v1.12 presented by Hwang Soo-yeon -->', "\n";
print '<!--               <URL> http://dapi.pr.co.kr/  -->', "\n";
print '<!--               <e-mail> dapi@innocent.com   -->', "\n";
print '<!--               < Dapi\'s Messed-up Studio >  -->', "\n";
print '<!------------------------------------------------>', "\n\n";

foreach $line (@dapioput) {
	if ($line =~ /<!--bbslog_include-->/i) {
		foreach $log (@logs) {
			($s_num, $s_name, $s_addr, $s_url, $s_subj, $s_note, $s_date, $s_res) = split(/ ;; /,$log);
			if ($s_url ne '') {
				if ($showurl ne 'on') {
					$s_url = '<A HREF="' . $s_url . '" TARGET="_blank">' . $urltext_1 . '</A>';
				} else { $s_url = '<A HREF="' . $s_url . '" TARGET="_blank">' . $s_url . '</A>'; }
			} else { if ($showurl ne 'on') { $s_url = $urltext_0; } }
			if ($s_addr ne '') {
				$s_name = '<A HREF="mailto:' . $s_addr . '">' . $s_name . '</A>';
			}
			@puttemp = @dapisput;
			foreach $inline (@puttemp) {
				$inline =~ s/num<!--d-->/$s_num/i;
				$inline =~ s/name<!--d-->/$s_name/i;
				$inline =~ s/url<!--d-->/$s_url/i;
				$inline =~ s/subj<!--d-->/$s_subj/i;
				$inline =~ s/note<!--d-->/$s_note/i;
				$inline =~ s/date<!--d-->/$s_date/i;
				$inline =~ s/res<!--d-->/$s_res/i;
				print $inline;
			}
		}
	} else {
		$line =~ s/(NAME="name")/$1 VALUE="$name"/i;
		$line =~ s/(NAME="addr")/$1 VALUE="$addr"/i;
		$line =~ s/(NAME="url")/$1 VALUE="$url"/i;

		$line =~ s/(NAME="cookie")/$1 $cook/i;

		$line =~ s/pnum<!--d-->/$pnum/i;
		$line =~ s/tpage<!--d-->/$tpage/i;
		$line =~ s/tline<!--d-->/$tline/i;
		$line =~ s/prev<!--d-->/$p_prev/i;
		$line =~ s/next<!--d-->/$p_next/i;

		print $line;
	}
}

exit;

# End of Mainstream


# Cookie data decode

sub cookie {
	@key_value_pairs = split(/;\s/, $ENV{'HTTP_COOKIE'});
	foreach $key_value (@key_value_pairs) {
		($key, $value) = split(/=/, $key_value);
		$value =~ tr/+/ /;
		$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
		$cookie_data{$key} = $value;
	}

	@pairs = split(/,/,$cookie_data{$cookid});
	foreach $pair (@pairs) {
		($key, $value) = split(/ \^n /, $pair);
		$cookie{$key} = $value;
	}
	$name = $cookie{'name'};
	$addr = $cookie{'addr'};
	$url = $cookie{'url'};
}

#  sub routine

sub regist {
	# ¥ ´

	($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $isdst) = localtime(time);
	$year += 1900 if length $year < 4;
	$year += 100 if $year <= 1970;
	$mon = $mon + 1;
	$thisday = ("","@","G","T","|","","") [$wday];
	if ($shortdate ne 'on') {
		$time_string = sprintf("%04d/%02d/%02d (%s) %02d:%02d:%02d", $year, $mon, $mday, $thisday, $hour, $min, $sec);
	} else { $time_string = sprintf("%02d/%02d (%s) %02d:%02d", $mon, $mday, $thisday, $hour, $min); }

	# file lock

	if ($lock ne 'off') { &filelock; }

	# α ȭ  Ʒ ۰ ߺǴ üũ
	
	open(LOGFILE, $logfile) || &return_error('dapibbs', 'log file  ʽϴ. ۹̼   ְų file   ɼ ֽϴ.');
	@logs = <LOGFILE>;
	close(LOGFILE);

	for ($cn = 0; $cn < 5; $cn++) {
		@prev_log = split(/ ;; /,$logs[$cn]);
		if (($prev_log[1] eq $name) && ($prev_log[5] eq $note)) { 
			&return_error('dapibbs', ' ߺ˴ϴ. ۾ ư   ų ε ʾҴ Ȯֽñ ٶϴ.'); 
		}
	}

	#  ȣ ϳ 

	$count = 0;
	@log_top = split(/ ;; /,$logs[0]);
	chop ($log_top[0]) if $log_top[0] =~ /\n$/;
	$count = $log_top[0] + 1;
	
	#  data ǵ 

	if ($name eq '') { $rname = ""; }
	else { $rname = $name; }
	
	# log file 

	$registlog = join(' ;; ', $count, $rname, $addr, $url, $subj, $note, $time_string, '');

	unshift (@logs, $registlog . "\n");
	$#logs = $max - 1;

	open(LOGFILE, ">$logfile") || &return_error('dapibbs', 'log file  ʽϴ. ۹̼   ְų file   ɼ ֽϴ.');
	print LOGFILE @logs;
	close(LOGFILE);

	# file unlock

	if ($lock ne 'off') { unlink($lockfile); }
}

# Cookie header 

sub mkcook {
	($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = gmtime(time + 2*30*24*60*60);

	$thisday = (Sunday,Monday,Tuesday,Wednesday,Thursday,Friday,Saturday)[$wday];
	$month = (Jan,Feb,Mar,Apr,May,Jun,Jul,Aug,Sep,Oct,Nov,Dec)[$mon];
	$year += 1900 if length $year < 4;
	$year += 100 if $year <= 1970;

	$date_gmt = sprintf("%s, %02d-%s-%04d %02d:%02d:%02d GMT", $thisday, $mday, $month, $year, $hour, $min, $sec);

	if ($cookie eq 'on') {
		print "Set-Cookie: $cookid=name \^n $name\,addr \^n $addr\,url \^n $url; expires=$date_gmt\n";
	} else { &cookie; }
}

# file lock sub routine

sub filelock {
	local($retry) = 9;
	while (!symlink(".", $lockfile)) {
		if (--$retry <= 0) { &return_error('dapibbs', 'file lockǾ ֽϴ. Ͽ  ǥð   lockȭ   ɼ ֽϴ.'); }
	sleep(2);
	}
}

# error ó sub routine

sub return_error {
	local($location, $message) = @_;
	print 'Content-type: text/html', "\n";
	print 'Pragma: no-cache', "\n\n";
	print '<HTML><HEAD><TITLE>500 CGI internal Error</TITLE></HEAD>', "\n";
	print '<BODY><H1>500 CGI internal Error</H1>', "\n";
	print $location, ' {Lk. <BR><BR>', "\n";
	print 'Please contact the webmaster, ', $webmaster, "\n";
	print 'and inform them of the time occurred, and', "\n";
	print ' anything you might have done that may have caused the error.<BR><BR>', "\n";
	print '<B>Error: ', $message, '</B><BR><BR>', "\n";
	print '</BODY></HTML>', "\n";
	if ($lock ne 'off') { unlink($lockfile); }
	exit;
}

# End of Script
